/***************************************************************************/

#ifndef RL_OTA_H
#define RL_OTA_H 1

/***************************************************************************/

#include "main.h"
#include <ArduinoOTA.h>

/***************************************************************************/

extern volatile uint16_t ota_updatestate;
extern volatile uint16_t ota_updateprogress;

/***************************************************************************/

enum{
OTA_UPDATESTATE_IDLE      = 0,    /* nothing to do */
OTA_UPDATESTATE_STARTING,
OTA_UPDATESTATE_ERROR,            /* progress contains error code */
OTA_UPDATESTATE_DONE
};

/*
** progress data beyond normal percentage
*/
enum{
OTA_PROGRESS_UFLASH     = 101,  /* when OTA_STATE_STARTING is set */
OTA_PROGRESS_FILESYSTEM         /* when OTA_STATE_STARTING is set */
};

/***************************************************************************/

/*
** prototypes
*/

void OTA_Startup( void );
void OTA_Handle( void );

/***************************************************************************/

#endif /* RL_OTA_H */

