#ifndef RL_TIME_H
#define RL_TIME_H 1

/***************************************************************************/

#include "main.h"
#include "rl_wifi.h"

/***************************************************************************/

/*
** some general time configuration
*/

#define MONDAYFIRST

#ifndef TIME_NTP_SERVER     /* could be defined in credentials.h */
  #define TIME_NTP_SERVER "pool.ntp.org"
#endif

#ifndef TIME_NTP_TIMEZONE   /* could be defined in credentials.h */
  #define TIME_NTP_TIMEZONE "CET-1CEST-2,M3.5.0/02:00:00,M10.5.0/03:00:00"   // enter your time zone (https://remotemonitoringsystems.ca/time-zone-abbreviations.php)
#endif

/*
** storage for current and reference (past) time 
*/

extern struct tm timecurrent;     /* last time got from system */
extern struct tm timereference;   /* time currently displayed */

/*
** bit arrays for easy and quick time digit change detection 
*/ 

#define DIGITS_NUMBEROF 6

extern byte digitcur[ DIGITS_NUMBEROF ]; /* one for each segment. "12 23 45" */
extern byte digitref[ DIGITS_NUMBEROF ]; /* one for each segment */

extern byte digitflags; /* flags represent a digit change to optimize updates, if needed */

#define DIGITB_HOURS_HIGH   0
#define DIGITB_HOURS_LOW    1
#define DIGITB_MINUTES_HIGH 2
#define DIGITB_MINUTES_LOW  3
#define DIGITB_SECONDS_HIGH 4
#define DIGITB_SECONDS_LOW  5

#define DIGITB_CHANGED      7 /* set for only the first cycle */

#define DIGITF_HOURS_HIGH   ( 1 << DIGITB_HOURS_HIGH      )
#define DIGITF_HOURS_LOW    ( 1 << DIGITB_HOURS_LOW       )
#define DIGITF_MINUTES_HIGH ( 1 << DIGITB_MINUTES_HIGH    )
#define DIGITF_MINUTES_LOW  ( 1 << DIGITB_MINUTES_LOW     )
#define DIGITF_SECONDS_HIGH ( 1 << DIGITB_SECONDS_HIGH    )
#define DIGITF_SECONDS_LOW  ( 1 << DIGITB_SECONDS_LOW     )

#define DIGITF_CHANGED      ( 1 << DIGITB_CHANGED         )

/***************************************************************************/

/*
** prototypes
*/

void Time_Startup( void );
void Time_Handle( void );

/***************************************************************************/

#endif /* RL_TIME_H */
