#ifndef RL_WIFI_H
#define RL_WIFI_H 1

/***************************************************************************/

#include <WiFi.h>
#include <WiFiUdp.h>

#include "main.h"

/***************************************************************************/

#if WIFI_CREDENTIALSFILE
  #include <credentials.h>
#else 
  #define WIFI_SSID             "YourWifiSSID"
  #define WIFI_PASSWORD         "YourPassword"
  #define OTA_PASSWORD          "YourOTAPassword"
  #define WEBSERVER_PASSWORD    "123456"
#endif

#define WIFI_ACCESSPOINT_NAME "ESP32_" APPLICATIONNAME_NS

/***************************************************************************/

/*
** the wifi mode state engine defines
*/
enum{
	WIFIMODE_STATE_CONNECTING = 0,
	WIFIMODE_STATE_CONNECTED,
	WIFIMODE_STATE_APMODE,
};

extern uint32_t wifi_mode;

/***************************************************************************/

/*
** prototypes
*/

void Wifi_SetupStationMode( void );
void Wifi_SetupAccessPointMode( void );
void Wifi_Handle( void );

/***************************************************************************/

#endif /* RL_WIFI_H */
